"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectTable = void 0;
const compass_components_1 = require("@mongodb-js/compass-components");
const react_1 = __importStar(require("react"));
function SelectTable(props) {
    const { items, columns, disabled, onChange } = props;
    const selectAll = items.every((item) => item.selected);
    const selectNone = items.every((item) => !item.selected);
    const handleSelectAllChange = (0, react_1.useCallback)((e) => {
        onChange(items.map((item) => ({ ...item, selected: !!e.target.checked })));
    }, [items, onChange]);
    const handleSelectItemChange = (0, react_1.useCallback)((e) => {
        onChange(items.map((item) => e.target.name === `select-${item.id}`
            ? { ...item, selected: !!e.target.checked }
            : item));
    }, [items, onChange]);
    return (react_1.default.createElement("div", { className: props.className },
        react_1.default.createElement(compass_components_1.Table, { shouldAlternateRowColor: true },
            react_1.default.createElement(compass_components_1.TableHead, null,
                react_1.default.createElement(compass_components_1.HeaderRow, null,
                    react_1.default.createElement(compass_components_1.HeaderCell, { key: "select-table-all-checkbox" },
                        react_1.default.createElement(compass_components_1.Checkbox, { "data-testid": "select-table-all-checkbox", "aria-label": "Select all", onChange: handleSelectAllChange, checked: selectAll, indeterminate: !selectAll && !selectNone, disabled: disabled })),
                    columns.map((col) => (react_1.default.createElement(compass_components_1.HeaderCell, { key: `col-${col[0]}` }, col[1]))))),
            react_1.default.createElement(compass_components_1.TableBody, null, items.map((item) => (react_1.default.createElement(compass_components_1.Row, { key: item.id },
                react_1.default.createElement(compass_components_1.Cell, null,
                    react_1.default.createElement(compass_components_1.Checkbox, { key: `select-${item.id}`, name: `select-${item.id}`, "data-testid": `select-${item.id}`, "aria-label": "Select item in row", onChange: handleSelectItemChange, checked: item.selected, disabled: disabled })),
                columns.map(([name]) => (react_1.default.createElement(compass_components_1.Cell, { key: `item-${name}`, "data-testid": `item-${item.id}-${name}` }, item[name]))))))))));
}
exports.SelectTable = SelectTable;
//# sourceMappingURL=select-table.js.map